using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        if (Session["DataSource"] == null)
        {
            OleDbConnection MyOleDbConnection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=|DataDirectory|\\Nwind.mdb;Persist Security Info=True");
            OleDbDataAdapter MyOleDbDataAdapter = new OleDbDataAdapter();
            MyOleDbDataAdapter.SelectCommand = new OleDbCommand("SELECT TOP 3 CustomerID, ContactName, Address, PostalCode FROM Customers", MyOleDbConnection);

            DataTable myDataTable = new DataTable();
            MyOleDbConnection.Open();

            try
            {
                MyOleDbDataAdapter.Fill(myDataTable);

            }
            finally
            {
                MyOleDbConnection.Close();
            }

            RadGrid1.DataSource = myDataTable;
            Session["DataSource"] = myDataTable;
        }
        else
        {
            RadGrid1.DataSource = Session["DataSource"];
        }
    }
    public DataTable LoadCountryNames()
    {
        DataTable dt = new DataTable();
        OleDbConnection dbCon = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=|DataDirectory|\\Nwind.mdb;Persist Security Info=True");
        dbCon.Open();

        OleDbDataAdapter adapter = new OleDbDataAdapter("SELECT ContactName From Customers", dbCon);
        adapter.Fill(dt);
        dbCon.Close();

        return dt;
    }
    protected void RadGrid1_UpdateCommand(object source, GridCommandEventArgs e)
    {
        GridEditableItem editedItem = (GridEditableItem)e.Item;
        GridEditManager editMan = editedItem.EditManager;



        foreach (GridColumn column in RadGrid1.MasterTableView.RenderColumns)
        {
            if (column is IGridEditableColumn)
            {
                IGridEditableColumn editableCol = (IGridEditableColumn)column;
                if ((editableCol.IsEditable))
                {
                    IGridColumnEditor editor = editMan.GetColumnEditor(editableCol);

                    string editorType = ((object)editor).ToString();
                    object editorValue = null;

                    if ((editor is GridTextColumnEditor))
                    {
                        editorValue = ((GridTextColumnEditor)editor).Text;
                    }
                    if ((editor is GridTemplateColumnEditor))
                    {
                        TableCell cell = (TableCell)((GridTemplateColumnEditor)editor).ContainerControl;
                        editorValue = ((RadComboBox)cell.FindControl("RadComboBox1")).SelectedItem.Text;
                    }
                    try
                    {
                        DataTable sourceTable = (DataTable)Session["DataSource"];
                        DataRow[] changedRows = sourceTable.Select("CustomerID = '" + editedItem["CustomerID"].Text + "'");

                        if ((column.UniqueName == "TemplateColumn"))
                        {
                            changedRows[0]["Country"] = editorValue;
                        }
                        else
                        {
                            changedRows[0][column.UniqueName] = editorValue;
                        }

                        sourceTable.AcceptChanges();
                    }
                    catch (Exception ex)
                    {
                        //Response.Write(ex.StackTrace);
                    }

                }
            }
        }
    }
    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if ((e.Item is GridDataItem))
        {
            GridDataItem dataItem = (GridDataItem)e.Item;

            RadComboBox combo = (RadComboBox)dataItem.FindControl("RadComboBox1");
            combo.DataSource = LoadCountryNames();
            combo.DataTextField = "ContactName";
            combo.DataValueField = "ContactName";
            combo.DataBind();
            combo.SelectedValue = DataBinder.Eval(e.Item.DataItem, "ContactName").ToString();
        }
    }    
    protected void RadAjaxManager1_AjaxRequest(object sender, AjaxRequestEventArgs e)
    {
        switch (e.Argument)
        {
            case "MyArguments":
                //execute custom logic here
                break;
        }
    }
}